#include "config.h"
#define TIME (30)
u8 play=0,key=0,last=0;
u16 temp=0;
u32 tick=0;
void FLASH_CONFIG(u32 addr){
	char count=0;
	FLASH_Unlock();
	FLASH_ClearFlag(FLASH_FLAG_EOP);
	FLASH_ClearFlag(FLASH_FLAG_PGERR);
	FLASH_ClearFlag(FLASH_FLAG_WRPRTERR);
 	while(addr<=FLASH_END){
		if(count++%20==0){
			GPIO_INVERSE(B,0);
			GPIO_INVERSE(C,0);
		}
 		FLASH_ErasePage(addr);
 		addr+=0x800;
 	}
	key=0;
	DAC_SET(0);
	GPIO_WRITE(B,0,0);
	GPIO_WRITE(C,0,1);
}
void SYS_CONFIG(void){
	RCC_CONFIG_APB1(DAC);
	RCC_CONFIG_APB2(AFIO);
	RCC_CONFIG_APB2(GPIOA);
	RCC_CONFIG_APB2(GPIOB);
	RCC_CONFIG_APB2(GPIOC);
	RCC_CONFIG_APB2(ADC1);
	GPIO_CONFIG(A,0,IN_FLOATING);//
	GPIO_CONFIG(A,3,AIN);//ADC
	GPIO_CONFIG(A,4,AIN);//DAC
	GPIO_CONFIG(B,0,Out_PP);//̵
	GPIO_CONFIG(C,0,Out_PP);//
	NVIC_CONFIG(EXTI0_IRQn,0);
	EXTI_CONFIG(A,0,Line0,Falling);
	DAC_CONFIG(1);
	ADC_CONFIG(3);
	FLASH_CONFIG(FLASH_ADDRESS);
	TICK_CONFIG(2250,0);
}
int main(void){
 	SYS_CONFIG();
	while(1);
}
void EXTI0_IRQHandler(void){
	if(EXTI_GetITStatus(EXTI_Line0)){
		SYS_DELAY_MS(15);
		if(!GPIO_READ_IN(A,0)){
			key=1;
			while(!GPIO_READ_IN(A,0));
		}
	}
	EXTI_ClearITPendingBit(EXTI_Line0);
}
void SysTick_Handler(void){
	if(key){
		if(play){
			if(tick%2==0){
				last=FLASH_READ(FLASH_ADDRESS+tick/2);
				DAC_SET(last);
			}
			else DAC_SET(last/2+FLASH_READ(FLASH_ADDRESS+tick/2+1)/2);
		}
		else{
			if(tick%4==0)temp=ADC_GET()>>8;
			else if(tick%4==2){
				temp+=(ADC_GET()&0xFF00);
				FLASH_WRITE(FLASH_ADDRESS+tick/2-1,temp);
			}
			if(tick%16000==0)GPIO_INVERSE(C,0);
		}
		if(++tick==32000*TIME){
			if(play)FLASH_CONFIG(FLASH_ADDRESS);
			else GPIO_WRITE(C,0,0);
			play=!play;
			tick=0;
		}
	}
}
